<template>
  <q-page class="column items-center justify-evenly">
    <div class="q-pa-md text-container">
      Witaj {{ user.nick }}. Na dobry początek poznajmy się lepiej.
    </div>

    <div class="q-pa-md">
      <div class="text-label">Podaj swój wiek:</div>
      <q-slider
        v-model="age"
        label
        label-always
        :min="18"
        :max="120"
        :step="1"
      />
    </div>

    <div class="q-pa-md">
      <div class="text-label">Osoby w jakim wieku Cię interesują?</div>
      <q-range
        v-model="ageRange"
        label
        label-always
        :min="0"
        :max="100"
        :step="1"
      />
    </div>
    <div class="q-pa-md">
      <q-select
        v-model="sex"
        :options="selectSex"
        label="Wybierz płeć"
        filled
      />
    </div>
    <div class="q-pa-md">
      <q-input v-model="about" label="Napisz coś o sobie" outlined />
    </div>

    <div class="q-pa-md">
      <div class="text-label">Podaj swój wzrost:</div>
      <q-slider
        v-model="height"
        label
        label-always
        :min="100"
        :max="240"
        :step="1"
      />
    </div>

    <q-btn @click="send" color="primary" label="Wyślij" />
    <q-dialog v-model="alert">
      <q-card>
        <q-card-section>
          <div class="text-h6">Gratulacje</div>
        </q-card-section>

        <q-card-section class="q-pt-none">
          Właśnie zakończył{{ sex === 'mężczyzna' ? 'eś' : 'aś' }} konfigurację
          konta
        </q-card-section>

        <q-card-actions align="right">
          <q-btn flat label="OK" color="primary" v-close-popup />
        </q-card-actions>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<script setup lang="ts">
import { ref } from 'vue';

import { useRouter } from 'vue-router';

import { useUserStore } from '../stores/user';
import { api } from '../boot/axios';

defineOptions({
  name: 'ConfigPage',
});

const router = useRouter();
const store = useUserStore();
const { user } = store;
const age = ref<number>(30);
const ageRange = ref<{ min: number; max: number }>({ min: 20, max: 50 });
const sex = ref<string>('mężczyzna');
const selectSex = ref<string[]>(['mężczyzna', 'kobieta']);
const about = ref<string>('');
const height = ref<number>(100);
const alert = ref<boolean>(false);

function send() {
  api
    .put('/user/configuration', {
      uuid: user.uuid,
      age: age.value,
      ageRange: [ageRange.value.min, ageRange.value.max],
      sex: sex.value === 'mężczyzna' ? 'men' : 'womana',
      about: about.value,
      height: height.value,
    })
    .then(({ data }) => {
      if (data.status === 'OK') {
        alert.value = true;
        router.push({ path: 'search' });
      }
    })
    .catch((error) => {
      console.error('Error sending data:', error);
    });
}
</script>

<style scoped>
.text-container {
  text-align: center;
  margin-bottom: 36px;
}

.text-label {
  margin-bottom: 37px;
  font-weight: bold;
}
</style>
